library MyTempDir;

uses SysUtils, SimUtils;

{$E .plg}
{$R *.res}

type
  //Callback function (via this main prog return PChars from get and post,
  TPlgCallBack=procedure(const AText: PChar); stdcall;
  //GET request
  TURLGet = procedure (const URL: PChar; const CallBack: TPlgCallBack); stdcall;
  //POST request, second param is data for post
  //Format: name1=value1#10name2=value2 etc
  TURLPost = procedure (const URL, Data: PChar; const CallBack: TPlgCallBack); stdcall;
  //Set return string to main app
  TSetRetResult=procedure(const AText: PChar); stdcall;
  //Save line to log file
  TSaveToLog = procedure (const AText: PChar); stdcall;
  //Show message (for not use dialogs)
  TShowMsg = function (const AText: PChar; const mode: Byte): Integer; stdcall; //0 - info, 1 - confirmation, 2 - Error
  //Save string to file
  TSaveToFile = procedure (const AName, AContent: PChar); stdcall;
  //This function return address of other funcs
  //Is: ShowMsg, GetHeaders, WaitTime, SetCookie, SetReferer and some functions for graph. 
  //if you want - i send you proto of this funcs
  //if function not found - it return nil
  TGetFuncAddr = function (const AFuncName: PChar): Pointer; stdcall;

var URLGet: TURLGet;
    URLPost: TURLPost;
    FDebug: Boolean;
    WorkDir: AnsiString;
    SaveToLog: TSaveToLog;
    SaveToFile: TSaveToFile;
    ShowMsg: TShowMsg;
    SetRetResult: TSetRetResult;
    RezFromMainApp: AnsiString;

    GetFuncAddr: TGetFuncAddr;

//-----------------------------------------------------------------------------------------------
// Main code ------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

//Function call my main app and return string
procedure PlgCallBack(const AText: PChar); stdcall;
begin
  RezFromMainApp:=StrPas(AText);
end;

//Help function for automate return string and convert types
function Get(const URL: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLGet(PChar(URL), @PlgCallBack);
  Result:=RezFromMainApp;
end;

//Function for post
function Post(const URL, Data: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLPost(PChar(URL), PChar(Data), @PlgCallBack);
  Result:=RezFromMainApp;
end;

//Runned on loading plugin
procedure PlgInit(const funcGet, funcPost, funcSaveToLog, funcGetFuncAddr, funcSaveToFile, funcRetResult: Pointer; const Debug: byte; const AWorkDir: PChar); stdcall;
begin
  @URLGet:=funcGet;             //address of GET
  @URLPost:=funcPost;           //address of POST
  @SaveToLog:=funcSavetoLog;    //address of SaveToLog
  @SaveToFile:=funcSaveToFile;  //address of SaveToFile
  @SetRetResult:=funcRetResult; //address of SetRetResult

  @GetFuncAddr:=funcGetFuncAddr;
  @ShowMsg:=GetFuncAddr('ShowMsg');

  FDebug:=Debug=1;              //Debug mode (Options - misc - log detail. medium, full - True, minimum - false)
  WorkDir:=StrPas(AWorkDir);    //Work folder (for save files)

  SetRetResult('mytempdir.com|1036');//Address from download. substring.
                                     //second param - min compatable version
end;

//Main function for return direct link
//Param - virtual link "http://sr1.mytempdir.com/116387"
//Need return direct link or errors:
//%deleted% - file was deleted from server
//%notfound% - file not found
//%user error|time for reconnect - second param may be undefined
//If return empty string - USD will try again later
procedure PlgGetDirectLink(const MyTempDirLink: PChar); stdcall;
const HTag1='Base64.decode(''';

var s: AnsiString;
    n: Integer;
    MyTempDirLnk: AnsiString;
    Pass: AnsiString;
begin
  n:=pos('@',MyTempDirLink);
  if n=0 then begin
    MyTempDirLnk:=MyTempDirLink;
    Pass:='';
  end else begin
    MyTempDirLnk:='http://'+copy(MyTempDirLink,n+1,Maxint);
    Pass:=copy(MyTempDirLink, 8, n-8);
  end;

  s:=Get(MyTempDirLnk);

  if FDebug then
    SaveToFile(PChar(WorkDir+'MyTempDir1.html'),PChar(s));

  if s='' then exit;

  //Errors from server
  if pos('404 Not Found',s)>0 then begin
    SetRetResult('%notfound%'); //Return to main prog
    exit;
  end;

  if pos('file was removed',s)>0 then begin
    SetRetResult('%deleted%');
    exit;
  end;

  if pos('Wrong file ID.',s)>0 then begin
    SetRetResult('%notfound%');
    exit;
  end;

  if pos('temporary blocked',s)>0 then
    exit;

  if pos('lease enter the password:',s)>0 then begin
    if pass='' then begin
      SetRetResult('%MyTempDir: For download you need enter password! Like: http://PasSwOrd@www.mytempdir.com/34324/'); //     
      exit;
    end;

    s:=parceForm(s,s);

    s:=repl(s,'password=','password='+Pass);

    if FDebug then
      SaveToLog(PChar('POST to: '+MyTempDirLnk+', data: '+s));


    s:=Post(MyTempDirLnk,s);

    if FDebug then
      SaveToFile(PChar(WorkDir+'MyTempDir2.html'),PChar(s));

    if s='' then exit;

    //Errors from server
    if pos('404 Not Found',s)>0 then begin
      SetRetResult('%notfound%');
      exit;
    end;

    if pos('Wrong Password!',s)>0 then begin
      SetRetResult('%Wrong Password!');
      exit;
    end;

    if pos('file was removed',s)>0 then begin
      SetRetResult('%deleted%');
      exit;
    end;

    if pos('Wrong file ID.',s)>0 then begin
      SetRetResult('%notfound%');
      exit;
    end;

    if pos('temporary blocked',s)>0 then
      exit;
  end;

  n:=pos(Htag1, s);
  if n=0 then exit;
  s:=copy(s, n+length(HTag1), MaxInt);

  n:=pos('''',s);
  if n=0 then exit;
  s:=DecodeBase64(copy(s,1,n-1));

  n:=pos('http://sr',s);
  if n=0 then exit;
  s:=copy(s, n, MaxInt);

  n:=pos('"',s);
  if n=0 then exit;

  s:=copy(s,1,n-1);

  SetRetResult(PChar(s)); //Return direct link. Format
  //URL|Download Ticket(in seconds)|Suport resume (0- no, 1 - autodetect)|Post data
  //http://dl.rapidshare.de/123213/file.zip|10 - download via get, try resume, wait 10 secs download ticket
  //http://dl.rapidshare.de/123213/file.zip|5|0|valcode=111 - download via POST, wait 5 secs Download ticket, no resume, post data "valcode=111"
end;

//Calling before unload.
procedure PlgDestroy; stdcall;
begin
  @URLGet:=nil;
  @URLPost:=nil;
end;

exports
  PlgInit,
  PlgGetDirectLink,
  PlgDestroy;
//Also is
// Calling if GET error or "download html" error (when USD download file)
//  TPlgOnError=   procedure(const URL, Error, Data: PChar); stdcall;
//Calling if file download succes (for rename/check)
//  TPlgOnSuccess= procedure(const URL, FileName: PChar); stdcall;
//Calling when checking file. CurrStatus - 0 - NotFound, 1 - Download Part, 2 - download Full
//  TPlgOnCheck=   procedure(const URL, FileName, Headers: PChar; const CurrStatus: Byte); stdcall;
//Calling when Options -> Plugins -> About plugin
//  TPlgGetAbout=  procedure; stdcall;
//Calling when Options -> Plugins -> Option of plugin
//  TPlgGetOptions=procedure; stdcall;

begin
end.
 
