library MyTempDir;

uses SysUtils, SimUtils;

{$E .plg}
{$R *.res}

type
  //  (     ,
  //  GET  POST.       )
  TPlgCallBack=procedure(const AText: PChar); stdcall;
  //  GET
  TURLGet = procedure (const URL: PChar; const CallBack: TPlgCallBack); stdcall;
  //  POST,   -    
  // : _1=_1 #10 _2=_2  
  TURLPost = procedure (const URL, Data: PChar; const CallBack: TPlgCallBack); stdcall;
  TSetRetResult=procedure(const AText: PChar); stdcall;
  //    
  TSaveToLog = procedure (const AText: PChar); stdcall;
  //  (   Dialogs)
  TShowMsg = function (const AText: PChar; const mode: Byte): Integer; stdcall; //0 - info, 1 - confirmation, 2 - Error
  //    .    
  TSaveToFile = procedure (const AName, AContent: PChar); stdcall;
  //    .      
  //  2  - ShowMsg (TShowMsg)  WaitTime (TWaitTime = procedure (const SecondsForWait: Longword))
  //      -  nil
  TGetFuncAddr = function (const AFuncName: PChar): Pointer; stdcall;

var URLGet: TURLGet;
    URLPost: TURLPost;
    FDebug: Boolean;
    WorkDir: AnsiString;
    SaveToLog: TSaveToLog;
    SaveToFile: TSaveToFile;
    ShowMsg: TShowMsg;
    SetRetResult: TSetRetResult;
    RezFromMainApp: AnsiString;

    GetFuncAddr: TGetFuncAddr;

//-----------------------------------------------------------------------------------------------
//    --------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

//  ,    1  
// GET  POST 
procedure PlgCallBack(const AText: PChar); stdcall;
begin
  RezFromMainApp:=StrPas(AText);
end;

// .   - ,  
// .  Get
function Get(const URL: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLGet(PChar(URL), @PlgCallBack);
  Result:=RezFromMainApp;
end;

// .   - ,   POST,
//   .  Post
function Post(const URL, Data: AnsiString): AnsiString;
begin
  RezFromMainApp:='';
  Result:='';
  URLPost(PChar(URL), PChar(Data), @PlgCallBack);
  Result:=RezFromMainApp;
end;

//    .
procedure PlgInit(const funcGet, funcPost, funcSaveToLog, funcGetFuncAddr, funcSaveToFile, funcRetResult: Pointer; const Debug: byte; const AWorkDir: PChar); stdcall;
begin
  @URLGet:=funcGet;             //   GET
  @URLPost:=funcPost;           //   POST
  @SaveToLog:=funcSavetoLog;    //   SaveToLog
  @SaveToFile:=funcSaveToFile;  //   SaveToFile
  @SetRetResult:=funcRetResult; //   SetRetResult

  @GetFuncAddr:=funcGetFuncAddr;   //     
  @ShowMsg:=GetFuncAddr('ShowMsg');//       ShowMsg

  FDebug:=Debug=1;              //  /
  WorkDir:=StrPas(AWorkDir);    //  (     )

  SetRetResult('mytempdir.com|1036');//   . .
                                     //   - 
                                     //   .
                                     //  URL    -  
                                     //   .   
end;

//  -    ""      
//      -  "http://sr1.mytempdir.com/116387"
//  ,     :
//%deleted% -     
//%notfound% -      ( ?)
//    -         
//  5  (      30   
//    ,   ""      )
procedure PlgGetDirectLink(const MyTempDirLink: PChar); stdcall;
const HTag1='Base64.decode(''';
      Htag2='value=''Continue to the Download';

var s: AnsiString;
    n: Integer;
    MyTempDirLnk: AnsiString;
    Pass: AnsiString;
begin
  DeleteFile(WorkDir+'MyTempDir1.html');
  DeleteFile(WorkDir+'MyTempDir2.html');

  n:=pos('@',MyTempDirLink);
  if n=0 then begin
    MyTempDirLnk:=MyTempDirLink;
    Pass:='';
  end else begin
    MyTempDirLnk:='http://'+copy(MyTempDirLink,n+1,Maxint);
    Pass:=copy(MyTempDirLink, 8, n-8);
  end;

  s:=Get(MyTempDirLnk);

  if FDebug then
    SaveToFile(PChar(WorkDir+'MyTempDir1.html'),PChar(s));

  if s='' then exit;

  //  
  if pos('404 Not Found',s)>0 then begin
    SetRetResult('%notfound%'); //     
    exit;
  end;

  if pos('file was removed',s)>0 then begin
    SetRetResult('%deleted%');
    exit;
  end;

  if pos('Wrong file ID.',s)>0 then begin
    SetRetResult('%notfound%');
    exit;
  end;

  if pos('temporary blocked',s)>0 then begin
    SetRetResult('%Server return: temporary blocked');
    exit;
  end;

  n:=Pos(Htag2, s);
  if n=0 then exit;
  n:=PosBack('<form', s, n);
  s:=parceForm(copy(s, n, MaxInt), s);

  if FDebug then
    SaveToLog(PChar(Format('POST to <%s>, data: %s', [MyTempDirLnk, s])));

  //2 
  s:=Post(MyTempDirLnk, s);

  if FDebug then
    SaveToFile(PChar(WorkDir+'MyTempDir2.html'),PChar(s));

  if s='' then exit;

  //  
  if pos('404 Not Found',s)>0 then begin
    SetRetResult('%notfound%'); //     
    exit;
  end;

  if pos('file was removed',s)>0 then begin
    SetRetResult('%deleted%');
    exit;
  end;

  if pos('Wrong file ID.',s)>0 then begin
    SetRetResult('%notfound%');
    exit;
  end;

  if pos('temporary blocked',s)>0 then begin
    SetRetResult('%Server return: temporary blocked');
    exit;
  end;

  if pos('lease enter the password:',s)>0 then begin
    if pass='' then begin
      SetRetResult('%MyTempDir: For download you need enter password! Like: http://PasSwOrd@www.mytempdir.com/34324/'); //     
      exit;
    end;

    s:=parceForm(s,s);

    s:=repl(s,'password=','password='+Pass);

    if FDebug then
      SaveToLog(PChar('POST to: '+MyTempDirLnk+', data: '+s));


    s:=Post(MyTempDirLnk,s);

    if FDebug then
      SaveToFile(PChar(WorkDir+'MyTempDir2.html'),PChar(s));

    if s='' then exit;

    //  
    if pos('404 Not Found',s)>0 then begin
      SetRetResult('%notfound%'); //     
      exit;
    end;

    if pos('Wrong Password!',s)>0 then begin
      SetRetResult('%Wrong Password!');
      exit;
    end;

    if pos('file was removed',s)>0 then begin
      SetRetResult('%deleted%');
      exit;
    end;

    if pos('Wrong file ID.',s)>0 then begin
      SetRetResult('%notfound%');
      exit;
    end;

    if pos('temporary blocked',s)>0 then
      exit;
  end;

  n:=pos(Htag1, s);
  if n=0 then exit;
  s:=copy(s, n+length(HTag1), MaxInt);

  n:=pos('''',s);
  if n=0 then exit;
  s:=DecodeBase64(copy(s,1,n-1));

  n:=pos('http://sr',s);
  if n=0 then exit;
  s:=copy(s, n, MaxInt);

  n:=pos('"',s);
  if n=0 then exit;

  s:=copy(s,1,n-1);

  SetRetResult(PChar(s));
end;

//   
procedure PlgDestroy; stdcall;
begin
  @URLGet:=nil;
  @URLPost:=nil;
end;

exports
  PlgInit,
  PlgGetDirectLink,
  PlgDestroy;

begin
end.

